function addCheka() {
  try {
    var script = document.createElement("script");
    script.type = "text/javascript";
    script.crossOrigin = "anonymous";
    script.src = "//cheka.biz.weibo.com/snippet"; // js-sdk地址
    script.onerror = function() {
      const img = document.createElement("img");
      img.src =
        "//cheka.biz.weibo.com/api/v1/events/collect?t=load.error&dl=" +
        encodeURIComponent(location.href) +
        "&rf=" +
        encodeURIComponent(document.referrer) +
        "&st=" +
        performance.now() +
        "&ts=" +
        Date.now();
    };
    var s = document.getElementsByTagName("script")[0];
    s.parentNode.insertBefore(script, s);
  } catch (e) {
    console.error(e);
  }
}

function getCheka() {
  if (window.wbadmt && window.wbadmt.send) {
    return window.wbadmt;
  }
  return null;
}

function send(data) {
  let c = getCheka();
  if (c) {
    c.send(data);
    return true;
  }
  return false;
}

function sendTracking(data) {
  if (!send(data)) {
    window.addEventListener(
      "cheka:ready",
      function() {
        send(data);
      },
      false
    );
  }
}

function sendPV(...args) {
  let c = getCheka();
  if (!c) {
    window.addEventListener("cheka:ready", function() {
      getCheka().captureRoute(...args);
    });
  } else {
    c.captureRoute(...args);
  }
}

function sendError(error) {
  let c = getCheka();
  if (!c) {
    window.addEventListener("cheka:ready", function() {
      getCheka().captureError(error);
    });
  } else {
    c.captureError(error);
  }
}

export { addCheka, getCheka, send, sendTracking, sendPV, sendError };
