"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.upload = void 0;
var upload_1 = require("./upload");
var observable_1 = require("./observable");
function upload(file, key, extension, config) {
    var options = {
        file: file,
        key: key,
        extension: extension,
        config: config
    };
    return new observable_1.Observable(function (observer) {
        var uploadManager = new upload_1.UploadManager(options, {
            onData: function (e) { return observer.next(e); },
            onError: function (e) { return observer.error(e); },
            onComplete: function (e) { return observer.complete(e); }
        });
        uploadManager.putFile();
        return uploadManager.stop.bind(uploadManager);
    });
}
exports.upload = upload;
//# sourceMappingURL=index.js.map