"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.setAutoUpdate = exports.updateProgress = exports.updateProgressCount = exports.observerProgress = exports.PROGRESS_MAP = exports.progress = void 0;
var PROGRESS_EVENT_NAME = "progress_before_upload";
// https://yemdpjdih2.feishu.cn/docx/ApSidkjqxoFEKLxkQdIc3bfTneg
var UNIT_TIME = 0.012 * 1000;
exports.progress = {
    mocknumber: 0
};
window.progress = {
    mocknumber: exports.progress.mocknumber
};
var timer = null;
exports.PROGRESS_MAP = {
    auto: 0,
    fileread: 20,
    md5: 50,
    storage: 80,
    upload: 100
};
function observerProgress(progressCallback) {
    exports.progress.mocknumber = 0;
    window.addEventListener(PROGRESS_EVENT_NAME, function (e) {
        var timeCount = e.detail.timeCount;
        exports.progress.mocknumber = Math.max(exports.progress.mocknumber, timeCount);
        progressCallback && progressCallback(exports.progress.mocknumber);
        if (exports.progress.mocknumber >= 100) {
            clearInterval(timer);
            timer = null;
        }
    });
}
exports.observerProgress = observerProgress;
function updateProgressCount(count) {
    var myEvent = new CustomEvent(PROGRESS_EVENT_NAME, {
        detail: {
            timeCount: count
        }
    });
    window.dispatchEvent(myEvent);
}
exports.updateProgressCount = updateProgressCount;
function updateProgress(type) {
    var timeCount = 0;
    if (type === "auto") {
        if (exports.progress.mocknumber === 99) {
            timeCount = 99;
        }
        else {
            timeCount = exports.progress.mocknumber + 1;
        }
    }
    else {
        timeCount = exports.PROGRESS_MAP[type];
        if (type === "storage") {
            timeCount = Math.max(exports.progress.mocknumber, exports.PROGRESS_MAP[type]);
            clearInterval(timer);
            timer = null;
        }
    }
    updateProgressCount(timeCount);
}
exports.updateProgress = updateProgress;
function setAutoUpdate(size) {
    if (timer) {
        return;
    }
    timer = setInterval(function () {
        queueMicrotask(function () {
            console.log("setAutoUpdate setInterval");
            if (exports.progress.mocknumber >= 100) {
                clearInterval(timer);
                timer = null;
                return;
            }
            updateProgress("auto");
        });
    }, (UNIT_TIME * size) / 100);
}
exports.setAutoUpdate = setAutoUpdate;
//# sourceMappingURL=progressbeforeupload.js.map