import * as BaseUpload from "./base/index.js";
export declare const FileAxios: import("axios").AxiosInstance;
interface SliceChunkParams {
    file: File;
    customerId: string;
    request_source: string;
    url?: string;
    isIntranet?: boolean;
    withCredentials?: boolean;
    video_type?: string;
    requestDomain?: string;
    requestPath?: string;
    name?: string;
    file_url?: string;
    progressCallback?: (progress: number) => void;
}
interface UpstreamParam {
    source: any;
    assetsHost?: string;
}
interface IurlStatus {
    fids: string;
    customerId: string;
    customer_id: string;
    request_source: string;
    isIntranet?: boolean;
    withCredentials?: boolean;
    requestDomain?: string;
    requestPath?: string;
}
interface IurlVideo {
    fids: string;
    customerId: string;
    customer_id: string;
    request_source: string;
    isIntranet?: boolean;
    withCredentials?: boolean;
    part?: string;
    highestQuality?: boolean;
    requestDomain?: string;
    requestPath?: string;
}
interface Ipic {
    pid: string;
    source: number;
}
interface IpicRelated {
    picInfos: Ipic[];
    customerId: string;
}
interface Ivideo {
    fid: string;
    source: number;
    shortUrl: string;
}
interface IvideoRelated {
    videos: Ivideo[];
    customerId: string;
}
declare class UpstreamApp {
    timeout: number;
    isValidPicID: Function;
    getImgURL: Function;
    getImageFormat: Function;
    getImgGeometry: Function;
    getImgLargeFileSize: Function;
    source: any;
    assetsHost: string;
    constructor(params: UpstreamParam);
    getSliceChunk(sliceChunkParams: SliceChunkParams, isIncrementally?: boolean): Promise<any>;
    getVideoStatus(iurlStatus: IurlStatus): Promise<any>;
    getVideoStatusV2(iurlStatus: IurlStatus): Promise<any>;
    getVideoInfo(iurlVideo: IurlVideo): Promise<any>;
    getOriginalVideoInfo(iurlVideo: IurlVideo): Promise<any>;
    savePicRelated(ipicRelated: IpicRelated): Promise<any>;
    saveVideoRelated(ivideoRelated: IvideoRelated): Promise<any>;
    getFileSliceChunk(sliceChunkParams: SliceChunkParams): Promise<any>;
    customUploadFile(params: {
        file: File;
        business_type: number;
        output_file_type: number;
        input_file_type: number;
        customerId: string;
        requestDomain?: string;
        isIntranet?: boolean;
        requestPath?: string;
    }): Promise<any>;
    mergeUploadFile(params: {
        file: File;
        request_source?: string;
        requestDomain?: string;
        isIntranet?: boolean;
        customerId?: string;
    }): Promise<any>;
}
export { UpstreamApp, BaseUpload };
