"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.BaseUpload = exports.UpstreamApp = exports.FileAxios = void 0;
var BaseUpload = require("./base/index.js");
exports.BaseUpload = BaseUpload;
var index_js_1 = require("./base/env/index.js");
var utils_1 = require("./base/utils");
var progressbeforeupload_js_1 = require("./base/progressbeforeupload.js");
var weiboimgbed_1 = require("./base/weiboimgbed");
var axios_1 = require("axios");
var MP4Box = require("mp4box");
exports.FileAxios = axios_1.default.create();
var sendParams;
var hostAssets = "https://assets.biz.weibo.com";
;
var host = index_js_1.default.get('host');
var intranet_host = index_js_1.default.get('intranet_host');
var checkTimehost = "";
if (process.env.NODE_ENV === "development") {
    checkTimehost = "//10.93.192.225:10010";
}
else {
    // checkTimehost = "//10.93.192.225:10010";
    checkTimehost = host;
}
// 视频初始化
var urlSlice = "/api/v1/video/media/init";
// 文件初始化
var fileuUrlSlice = "/api/v1/file/init";
var urlStatus = "/api/v1/video/media/showStatus";
var urlStatusV2 = "/api/v1/video/media/showStatusV2";
var urlVideoBatch = "/api/v1/video/media/showBatch";
var urlVideoBatchByKa = "/api/v1/video/media/showBatchByKa";
var urlVideoBatchByPartKa = "/api/v1/video/media/showBatchByPartKa";
var urlOriginalVideoInfo = "/api/v1/video/media/showBatchOriginalVideo";
// 图片关联
var picUrlRelated = "/api/v1/assets/pic/save";
// 视频关联
var videoUrlRelated = "/api/v1/assets/video/save";
//获取时间戳
var getcheckTime = checkTimehost + "/api/v1/video/media/checkTime";
var UpstreamApp = /** @class */ (function () {
    function UpstreamApp(params) {
        // this.uid = params.uid;
        this.timeout = 10000;
        this.isValidPicID = weiboimgbed_1.isValidPicID;
        this.getImgURL = weiboimgbed_1.getImgURL;
        this.getImageFormat = weiboimgbed_1.getImageFormat;
        this.getImgLargeFileSize = weiboimgbed_1.getImgLargeFileSize;
        this.getImgGeometry = weiboimgbed_1.getImgGeometry;
        this.source = params.source;
        this.assetsHost = params.assetsHost;
    }
    // 获取切片
    UpstreamApp.prototype.getSliceChunk = function (sliceChunkParams, isIncrementally) {
        var _a;
        if (isIncrementally === void 0) { isIncrementally = false; }
        return __awaiter(this, void 0, void 0, function () {
            var mp4boxfile, md5, _b, response, localmd5, localinitTime, times, initTime, sendParams, domain, requestPath, url, e_1;
            return __generator(this, function (_c) {
                switch (_c.label) {
                    case 0:
                        progressbeforeupload_js_1.observerProgress(sliceChunkParams.progressCallback);
                        !isIncrementally &&
                            progressbeforeupload_js_1.setAutoUpdate(((_a = sliceChunkParams === null || sliceChunkParams === void 0 ? void 0 : sliceChunkParams.file) === null || _a === void 0 ? void 0 : _a.size) / (1024 * 1024));
                        mp4boxfile = MP4Box.createFile();
                        // eslint-disable-next-line @typescript-eslint/no-unused-vars
                        mp4boxfile.onReady = function (info) {
                            var eventvalue = JSON.stringify(info);
                            utils_1.sendTracking({
                                eventid: 1008168,
                                eventtype: "asset-upload-encodeType",
                                eventvalue: eventvalue
                            });
                        };
                        mp4boxfile.onError = function () { };
                        utils_1.file2ArrayBuffer(sliceChunkParams.file)
                            .then(function (res) {
                            var arrBuffer = res;
                            arrBuffer.fileStart = 0;
                            mp4boxfile.appendBuffer(arrBuffer);
                            mp4boxfile.flush();
                        })
                            .catch(function (err) {
                            console.log(err);
                        });
                        !isIncrementally && progressbeforeupload_js_1.updateProgress("fileread");
                        if (!isIncrementally) return [3 /*break*/, 2];
                        return [4 /*yield*/, utils_1.computeMd5Incrementally(sliceChunkParams.file)];
                    case 1:
                        _b = _c.sent();
                        return [3 /*break*/, 4];
                    case 2: return [4 /*yield*/, utils_1.computeMd5(sliceChunkParams.file)];
                    case 3:
                        _b = _c.sent();
                        _c.label = 4;
                    case 4:
                        md5 = _b;
                        !isIncrementally && progressbeforeupload_js_1.updateProgress("md5");
                        localmd5 = localStorage.getItem(md5);
                        localinitTime = (localmd5 && JSON.parse(localmd5).initTime) || 0;
                        times = new Date().getTime() - localinitTime < 14400000;
                        if (localmd5 && times && JSON.parse(localmd5).data) {
                            !isIncrementally && progressbeforeupload_js_1.updateProgress("storage");
                            return [2 /*return*/, JSON.parse(localStorage.getItem(md5))];
                        }
                        initTime = new Date().getTime();
                        sendParams = {
                            name: sliceChunkParams.file.name,
                            length: sliceChunkParams.file.size,
                            check: md5,
                            request_time: initTime,
                            source: sliceChunkParams.request_source || this.source,
                            customer_id: sliceChunkParams.customerId,
                            video_type: sliceChunkParams.video_type
                        };
                        domain = sliceChunkParams.requestDomain
                            ? sliceChunkParams.requestDomain
                            : sliceChunkParams.isIntranet
                                ? intranet_host
                                : host;
                        requestPath = sliceChunkParams.requestPath || urlSlice;
                        _c.label = 5;
                    case 5:
                        _c.trys.push([5, 7, , 8]);
                        url = "" + domain + requestPath + "?customer_id=" + sliceChunkParams.customerId + "&request_source=" + sendParams.source;
                        return [4 /*yield*/, exports.FileAxios.post(url, sendParams, {
                                timeout: this.timeout,
                                withCredentials: !sliceChunkParams.isIntranet
                            })];
                    case 6:
                        response = _c.sent();
                        if (response.data.data && response.data.data.upload_id) {
                            response.data["md5"] = md5;
                            response.data["initTime"] = initTime;
                            localStorage.setItem(md5, JSON.stringify(response.data));
                        }
                        return [2 /*return*/, response.data];
                    case 7:
                        e_1 = _c.sent();
                        return [3 /*break*/, 8];
                    case 8: return [2 /*return*/];
                }
            });
        });
    };
    // 查询视频状态
    UpstreamApp.prototype.getVideoStatus = function (iurlStatus) {
        return __awaiter(this, void 0, void 0, function () {
            var response, source, domain, requestPath, e_2;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        source = iurlStatus.request_source || this.source;
                        domain = iurlStatus.requestDomain
                            ? iurlStatus.requestDomain
                            : iurlStatus.isIntranet
                                ? intranet_host
                                : host;
                        requestPath = iurlStatus.requestPath || urlStatus;
                        _a.label = 1;
                    case 1:
                        _a.trys.push([1, 3, , 4]);
                        return [4 /*yield*/, exports.FileAxios.get("" + domain + requestPath, {
                                params: __assign(__assign({}, iurlStatus), { customer_id: iurlStatus.customerId || iurlStatus.customer_id, request_source: source }),
                                timeout: this.timeout,
                                withCredentials: iurlStatus.hasOwnProperty("withCredentials")
                                    ? iurlStatus.withCredentials
                                    : !iurlStatus.isIntranet
                            })];
                    case 2:
                        response = _a.sent();
                        return [2 /*return*/, response];
                    case 3:
                        e_2 = _a.sent();
                        console.log(e_2);
                        return [3 /*break*/, 4];
                    case 4: return [2 /*return*/];
                }
            });
        });
    };
    // 查询视频状态（新）
    UpstreamApp.prototype.getVideoStatusV2 = function (iurlStatus) {
        return __awaiter(this, void 0, void 0, function () {
            var response, source, domain, requestPath, e_3;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        source = iurlStatus.request_source || this.source;
                        domain = iurlStatus.requestDomain
                            ? iurlStatus.requestDomain
                            : iurlStatus.isIntranet
                                ? intranet_host
                                : host;
                        requestPath = iurlStatus.requestPath || urlStatusV2;
                        _a.label = 1;
                    case 1:
                        _a.trys.push([1, 3, , 4]);
                        return [4 /*yield*/, exports.FileAxios.get("" + domain + requestPath, {
                                params: __assign(__assign({}, iurlStatus), { customer_id: iurlStatus.customerId || iurlStatus.customer_id, request_source: source }),
                                timeout: this.timeout,
                                withCredentials: iurlStatus.hasOwnProperty("withCredentials")
                                    ? iurlStatus.withCredentials
                                    : !iurlStatus.isIntranet
                            })];
                    case 2:
                        response = _a.sent();
                        return [2 /*return*/, response];
                    case 3:
                        e_3 = _a.sent();
                        console.log(e_3);
                        return [3 /*break*/, 4];
                    case 4: return [2 /*return*/];
                }
            });
        });
    };
    // 视频封面视频地址
    UpstreamApp.prototype.getVideoInfo = function (iurlVideo) {
        return __awaiter(this, void 0, void 0, function () {
            var response, source, domain, requestPath, e_4;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        source = iurlVideo.request_source || this.source;
                        domain = iurlVideo.requestDomain
                            ? iurlVideo.requestDomain
                            : iurlVideo.isIntranet
                                ? intranet_host
                                : host;
                        requestPath = iurlVideo.requestPath
                            ? iurlVideo.requestPath
                            : iurlVideo.part
                                ? urlVideoBatchByPartKa
                                : iurlVideo.highestQuality
                                    ? urlVideoBatchByKa
                                    : urlVideoBatch;
                        _a.label = 1;
                    case 1:
                        _a.trys.push([1, 3, , 4]);
                        return [4 /*yield*/, exports.FileAxios.get("" + domain + requestPath, {
                                params: __assign(__assign({}, iurlVideo), { customer_id: iurlVideo.customerId || iurlVideo.customer_id, request_source: source }),
                                timeout: this.timeout,
                                withCredentials: iurlVideo.hasOwnProperty("withCredentials")
                                    ? iurlVideo.withCredentials
                                    : !iurlVideo.isIntranet
                            })];
                    case 2:
                        response = _a.sent();
                        return [2 /*return*/, response];
                    case 3:
                        e_4 = _a.sent();
                        return [3 /*break*/, 4];
                    case 4: return [2 /*return*/];
                }
            });
        });
    };
    UpstreamApp.prototype.getOriginalVideoInfo = function (iurlVideo) {
        return __awaiter(this, void 0, void 0, function () {
            var response, source, domain, e_5;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        source = iurlVideo.request_source || this.source;
                        domain = iurlVideo.isIntranet ? intranet_host : host;
                        _a.label = 1;
                    case 1:
                        _a.trys.push([1, 3, , 4]);
                        return [4 /*yield*/, exports.FileAxios.get("" + domain + urlOriginalVideoInfo, {
                                params: __assign(__assign({}, iurlVideo), { customer_id: iurlVideo.customerId || iurlVideo.customer_id, request_source: source }),
                                timeout: this.timeout,
                                withCredentials: iurlVideo.hasOwnProperty("withCredentials")
                                    ? iurlVideo.withCredentials
                                    : !iurlVideo.isIntranet
                            })];
                    case 2:
                        response = _a.sent();
                        return [2 /*return*/, response];
                    case 3:
                        e_5 = _a.sent();
                        return [3 /*break*/, 4];
                    case 4: return [2 /*return*/];
                }
            });
        });
    };
    // 图片关联资产
    UpstreamApp.prototype.savePicRelated = function (ipicRelated) {
        return __awaiter(this, void 0, void 0, function () {
            var response, host, picUrlRelatedUrl, e_6;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        host = this.assetsHost || hostAssets;
                        picUrlRelatedUrl = host + picUrlRelated + "?customer_id=" + ipicRelated.customerId;
                        _a.label = 1;
                    case 1:
                        _a.trys.push([1, 3, , 4]);
                        return [4 /*yield*/, exports.FileAxios.post(picUrlRelatedUrl, ipicRelated, {
                                timeout: this.timeout,
                                withCredentials: true,
                                headers: {
                                    "Content-Type": "application/json;charset=utf-8"
                                },
                                transformRequest: [
                                    function (data, headers) {
                                        return JSON.stringify(data);
                                    }
                                ]
                            })];
                    case 2:
                        response = _a.sent();
                        return [2 /*return*/, response];
                    case 3:
                        e_6 = _a.sent();
                        return [3 /*break*/, 4];
                    case 4: return [2 /*return*/];
                }
            });
        });
    };
    // 视频关联资产
    UpstreamApp.prototype.saveVideoRelated = function (ivideoRelated) {
        return __awaiter(this, void 0, void 0, function () {
            var response, host, videoUrlRelatedUrl, e_7;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        host = this.assetsHost || hostAssets;
                        videoUrlRelatedUrl = host + videoUrlRelated + "?customer_id=" + ivideoRelated.customerId;
                        _a.label = 1;
                    case 1:
                        _a.trys.push([1, 3, , 4]);
                        return [4 /*yield*/, exports.FileAxios.post(videoUrlRelatedUrl, ivideoRelated, {
                                timeout: this.timeout,
                                withCredentials: true,
                                headers: {
                                    "Content-Type": "application/json;charset=utf-8"
                                },
                                transformRequest: [
                                    function (data, headers) {
                                        return JSON.stringify(data);
                                    }
                                ]
                            })];
                    case 2:
                        response = _a.sent();
                        return [2 /*return*/, response];
                    case 3:
                        e_7 = _a.sent();
                        return [3 /*break*/, 4];
                    case 4: return [2 /*return*/];
                }
            });
        });
    };
    // 文件切片
    UpstreamApp.prototype.getFileSliceChunk = function (sliceChunkParams) {
        return __awaiter(this, void 0, void 0, function () {
            var md5_file, name, md5_key, response, localmd5, localinitTime, times, sendParams, initTime, domain, requestPath, e_8;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, utils_1.computeMd5(sliceChunkParams.file)];
                    case 1:
                        md5_file = _a.sent();
                        name = sliceChunkParams.name || sliceChunkParams.file.name;
                        md5_key = md5_file + "_" + encodeURIComponent(name) + (sliceChunkParams.file_url ? "_" + sliceChunkParams.file_url : "");
                        localmd5 = window.localStorage.getItem(md5_key);
                        localinitTime = (localmd5 && JSON.parse(localmd5).initTime) || 0;
                        times = new Date().getTime() - localinitTime < 7200000;
                        if (localmd5 && times && JSON.parse(localmd5).data) {
                            return [2 /*return*/, JSON.parse(localStorage.getItem(md5_key))];
                        }
                        sendParams = {
                            name: name,
                            length: sliceChunkParams.file.size,
                            check: md5_file,
                            source: sliceChunkParams.request_source || this.source,
                            customer_id: sliceChunkParams.customerId
                        };
                        initTime = new Date().getTime();
                        domain = sliceChunkParams.requestDomain
                            ? sliceChunkParams.requestDomain
                            : sliceChunkParams.isIntranet
                                ? intranet_host
                                : host;
                        requestPath = sliceChunkParams.requestPath || fileuUrlSlice;
                        _a.label = 2;
                    case 2:
                        _a.trys.push([2, 4, , 5]);
                        return [4 /*yield*/, exports.FileAxios.post("" + domain + requestPath + "?customer_id=" + sliceChunkParams.customerId + "&request_source=" + sendParams.source + (sliceChunkParams.file_url
                                ? "&file_url=" + sliceChunkParams.file_url
                                : ""), sendParams, {
                                timeout: this.timeout,
                                withCredentials: !sliceChunkParams.isIntranet
                            })];
                    case 3:
                        response = _a.sent();
                        if (response.data.data.uploadID) {
                            response.data["md5"] = md5_key;
                            response.data["initTime"] = initTime;
                            window.localStorage.setItem(md5_key, JSON.stringify(response.data));
                            return [2 /*return*/, response.data];
                        }
                        return [3 /*break*/, 5];
                    case 4:
                        e_8 = _a.sent();
                        return [3 /*break*/, 5];
                    case 5: return [2 /*return*/];
                }
            });
        });
    };
    UpstreamApp.prototype.customUploadFile = function (params) {
        return __awaiter(this, void 0, void 0, function () {
            var formData, input_file_type, output_file_type, business_type, response, domain, requestPath, e_9;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        formData = new FormData();
                        input_file_type = params.hasOwnProperty("input_file_type")
                            ? params["input_file_type"]
                            : 0;
                        output_file_type = params.hasOwnProperty("output_file_type")
                            ? params["output_file_type"]
                            : 0;
                        business_type = params.hasOwnProperty("business_type")
                            ? params["business_type"]
                            : 0;
                        // 添加文件到表单数据
                        formData.append("file", params.file, params.file.name);
                        formData.append("request_source", "asset");
                        formData.append("input_file_type", "" + input_file_type);
                        formData.append("output_file_type", "" + output_file_type);
                        formData.append("business_type", "" + business_type);
                        domain = params.requestDomain
                            ? params.requestDomain
                            : params.isIntranet
                                ? intranet_host
                                : host;
                        requestPath = params.requestPath || "/api/v1/file/customUpload";
                        _a.label = 1;
                    case 1:
                        _a.trys.push([1, 3, , 4]);
                        return [4 /*yield*/, exports.FileAxios.post("" + domain + requestPath + "?customer_id=" + params.customerId, formData, {
                                timeout: this.timeout,
                                withCredentials: !params.isIntranet
                            })];
                    case 2:
                        response = _a.sent();
                        return [2 /*return*/, response.data];
                    case 3:
                        e_9 = _a.sent();
                        return [2 /*return*/, null];
                    case 4: return [2 /*return*/];
                }
            });
        });
    };
    UpstreamApp.prototype.mergeUploadFile = function (params) {
        return __awaiter(this, void 0, void 0, function () {
            var formData, response, domain, requestPath, e_10;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        formData = new FormData();
                        // 添加文件到表单数据
                        formData.append("file", params.file, params.file.name);
                        formData.append("request_source", "asset");
                        (params === null || params === void 0 ? void 0 : params.request_source) &&
                            formData.append("request_source", "" + params.request_source);
                        domain = params.requestDomain
                            ? params.requestDomain
                            : params.isIntranet
                                ? intranet_host
                                : host;
                        requestPath = "/api/v1/file/mergeUpload";
                        _a.label = 1;
                    case 1:
                        _a.trys.push([1, 3, , 4]);
                        return [4 /*yield*/, exports.FileAxios.post("" + domain + requestPath + "?customer_id=" + ((params === null || params === void 0 ? void 0 : params.customerId) || ""), formData, {
                                timeout: this.timeout,
                                withCredentials: !params.isIntranet
                            })];
                    case 2:
                        response = _a.sent();
                        return [2 /*return*/, response.data];
                    case 3:
                        e_10 = _a.sent();
                        return [2 /*return*/, null];
                    case 4: return [2 /*return*/];
                }
            });
        });
    };
    return UpstreamApp;
}());
exports.UpstreamApp = UpstreamApp;
//# sourceMappingURL=up_stream.js.map