import { UploadManager } from "./upload";
import { Observable } from "./observable";

function upload(file, key, extension, config) {
  let options = {
    file,
    key,
    extension,
    config
  };
  return new Observable(observer => {
    let uploadManager = new UploadManager(options, {
      onData: e => observer.next(e),
      onError: e => observer.error(e),
      onComplete: e => observer.complete(e)
    });
    uploadManager.putFile();
    return uploadManager.stop.bind(uploadManager);
  });
}
export { upload };
