import { crc32 } from "./crc32";

export function isValidPicID(pid) {
  pid = String(pid);
  let len = pid.length;

  var pat = /^[0-9a-zA-Z]{21,40}$/;
  return pat.test(pid);
}
/**
 *
 * @param {*} pid
 * @param {*} type
{
  middle: 'bmiddle',
  large: 'large',
  bmiddle: 'bmiddle',
  small: 'small',
  thumbnail: 'thumbnail',
  square: 'square',
  orignal: 'large'
}
 * @param {*} https
 */
export function getImgURL(pid, type, https) {
  var url;
  if (typeof type == "undefined") type = "bmiddle";
  if (typeof https == "undefined") https = false;
  if (pid[9] == "w" || (pid[9] == "y" && pid.length >= 32)) {
    var zone = (crc32(pid) & 3) + 1;
    var ext = pid[21] == "g" ? "gif" : "jpg";
    if (https) {
      url =
        pid[9] == "w"
          ? "https://ww" + zone + ".sinaimg.cn/" + type + "/" + pid + "." + ext
          : "https://wx" + zone + ".sinaimg.cn/" + type + "/" + pid + "." + ext;
    } else {
      url =
        pid[9] == "w"
          ? "http://ww" + zone + ".sinaimg.cn/" + type + "/" + pid + "." + ext
          : "http://wx" + zone + ".sinaimg.cn/" + type + "/" + pid + "." + ext;
    }
  } else {
    var zone = (parseInt(pid.substr(-2, 2), 16) & 0xf) + 1;
    if (https) {
      url = "https://ss" + zone + ".sinaimg.cn/" + type + "/" + pid + "&690";
    } else {
      url = "http://ss" + zone + ".sinaimg.cn/" + type + "/" + pid + "&690";
    }
  }

  return url;
}

export function getImageFormat(pid) {
  var ext = pid[21] == "g" ? "gif" : "jpg";
  return ext;
}

export function getImgGeometry(pid) {
  pid = String(pid);
  var geo;

  if (pid.length >= 32 && pid[22] >= "1") {
    geo = new Object();
    geo.width = parseInt(pid.substr(23, 3), 36);
    geo.height = parseInt(pid.substr(26, 3), 36);
  }

  return geo;
}

export function getImgLargeFileSize(pid) {
  var size = 0;
  var pid = String(pid);
  var dn, base, exp, rem;
  if (pid.length >= 32 && pid[22] >= "2") {
    dn = parseInt(pid.substr(29, 3), 36);
    base = dn & 0x3ff;
    exp = (dn >>> 10) & 0x3;
    rem = (dn >>> 12) & 0xf;

    size = base << (exp * 10);
    size += (rem * 93) << ((exp > 0 ? exp - 1 : exp) * 10);
  }
  return size;
}
