const path = require("path");
console.log("*****", process.env.NODE_ENV);

module.exports = {
  mode: "production",
  devtool: "source-map",
  entry: "./src/up_stream.ts",
  module: {
    rules: [
      {
        test: /\.ts$/,
        use: "ts-loader",
        exclude: /node_modules/
      }
    ]
  },
  resolve: {
    extensions: [".ts", ".js"]
  },
  optimization: {
    occurrenceOrder: false
  },
  output: {
    filename: "wd-ad-file-sdk.js",
    path: path.resolve(__dirname, "dist"),
    library: "UpstreamApp",
    libraryTarget: "umd"
  },
  plugins: []
};
